//ME 208 Fish Feeder

//servo library
#include <Servo.h>

Servo myservo; //create servo object to control a servo

int pos; //variable to store the servo position

int servopin=2; //set servopin to pin

//set gear motor to pins
int AIN1=13;
int AIN2=12;
int PWMA=11;

int AIN3=10;
int AIN4=9;
int PWMB=8;

//set button to pin
int button=3;

//set buttonval as an integer
int buttonval;

void setup()
{
  Serial.begin(9600);
  
  //set servo to pin number
  myservo.attach(servopin);
  
  //set gear motor to output
  //gear motor 1
  pinMode(AIN1,OUTPUT);
  pinMode(AIN2,OUTPUT);
  pinMode(PWMA,OUTPUT);
  
  //gear motor 2
  pinMode(AIN3,OUTPUT);
  pinMode(AIN4,OUTPUT);
  pinMode(PWMB,OUTPUT);
  
  //set button to input pullup
  pinMode(button, INPUT_PULLUP);
}

void loop()
{
  //send button value to serial monitor
  Serial.println(buttonval);
  
  //read button to buttonval
  buttonval=digitalRead(button);
  
  if(buttonval==LOW){ //button was pushed
    
    delay(5000); //delay to allow the closure of lid after button push
    
    //call gearmotoron function
    gearon();
   
   	//servo rotation from 0 to 180 to 0
    servoon();
   
   	delay(5000); /*has the gear motors run for 5 more
    secs after the completion of the servo motor from 0 to 
    180 to 0 if more time is wanted for the feeder to travel
    before dispensing food, extend the delay time*/

    /*repeat function or adjust for additional functions and 
    modifications for desired pattern*/
    gearon();
   
   	//servo rotation from 0 to 180 to 0
    servoon();
   
   	delay(5000); /*has the gear motors run for 5 more
    secs after the completion of the servo motor from 0 to 
    180 to 0 if more time is wanted for the feeder to travel
    before dispensing food, extend the delay time*/
   	
 }
  
  else {
    //gear motors are stopped
  	gearoff();
  	
   	/*servo is set to defualt of 0 degrees when button
    is not pushed*/
   	myservo.write(0);
 }
}

//formulas
//gear motors
void gearon() {
  digitalWrite(AIN1,HIGH); //direction of the turn
  digitalWrite(AIN2,LOW); //flip HIGH and LOW for direction
  analogWrite(PWMA,200); /*set values between 0 and 255, speed
  can be adjusted according to the type of path needed,
  difference in speeds from the two gear motors allow the 
  vehicle to go in a circle*/
  digitalWrite(AIN3,HIGH); //direction HIGH or LOW
  digitalWrite(AIN4,LOW); //direction HIGH or LOW
  analogWrite(PWMB,200); //speed, values 0 to 255
}
void gearoff() {
  //gear motors are stopped
  digitalWrite(AIN1,LOW);
  digitalWrite(AIN2,LOW);
  analogWrite(PWMA,0);
  digitalWrite(AIN3,LOW);
  digitalWrite(AIN4,LOW);
  analogWrite(PWMB,0);
}
//servo motor
//servo rotation from 0 to 180 to 0
void servoon() {
  for (pos = 0; pos <= 180; pos++) {
    myservo.write(pos); //tell servo to go to pos
    delay(15); //wait for servo to reach pos
  }
  for (pos = 180; pos >= 0; pos--) {
    myservo.write(pos); //position of servo
    delay(15); //time to go to position
  }
}